/*****************************************************************************

    TRAVIS - Trajectory Analyzer and Visualizer

    http://www.travis-analyzer.de/

    Copyright (c) 2009-2026 Martin Brehm
                  2012-2017 Martin Thomas
                  2016-2020 Sascha Gehrke

    Please cite:  J. Chem. Phys. 2020, 152 (16), 164105.         (DOI 10.1063/5.0005078 )
                  J. Chem. Inf. Model. 2011, 51 (8), 2007-2023.  (DOI 10.1021/ci200217w )

    This file was written by Martin Brehm.

    ---------------------------------------------------------------------------

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*****************************************************************************/


// This must always be the first include directive
#include "config.h"

#include "random.h"

#include <limits>
#include <math.h>


const char *GetRevisionInfo_random(unsigned int len) {
	static char buf[256];
	GET_REVISION_INFO( buf, len );
	return buf;
}


const char *GetSourceVersion_random() {
	static char buf[256];
	GET_SOURCE_VERSION( buf );
	return buf;
}


CRandom::CRandom()
{
	seed = 123456789;
	r4_nor_setup ( kn, fn, wn );
	r4_exp_setup ( ke, fe, we );
}


CRandom::~CRandom()
{
}







double CRandom2::UniformRand( double mi, double ma ) {

	return mi + this->genrand_real2() * (ma - mi);
}



long CRandom2::UniformRandInteger( long mi, long ma ) {

	return mi + int(this->genrand_real2() * (ma - mi));
}



// Source: https://en.wikipedia.org/wiki/Box%E2%80%93Muller_transform
double CRandom2::NormalRand( double mu, double sigma ) {

	const double epsilon = std::numeric_limits<double>::min();
	const double two_pi = 2.0*3.14159265358979323846;

	m_bGenerate = !m_bGenerate;

	if (!m_bGenerate)
		return m_fZ1 * sigma + mu;

	double u1, u2;
	do {
		u1 = this->rand() * (1.0 / this->rand_max() );
		u2 = this->rand() * (1.0 / this->rand_max() );
	} while ( u1 <= epsilon );

	m_fZ0 = sqrt(-2.0 * log(u1)) * cos(two_pi * u2);
	m_fZ1 = sqrt(-2.0 * log(u1)) * sin(two_pi * u2);
	return m_fZ0 * sigma + mu;
}


/* 
   A C-program for MT19937, with initialization improved 2002/1/26.
   Coded by Takuji Nishimura and Makoto Matsumoto.

   Before using, initialize the state by using init_genrand(seed)  
   or init_by_array(init_key, key_length).

   Copyright (C) 1997 - 2002, Makoto Matsumoto and Takuji Nishimura,
   All rights reserved.                          
   Copyright (C) 2005, Mutsuo Saito,
   All rights reserved.                          

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions
   are met:

     1. Redistributions of source code must retain the above copyright
        notice, this list of conditions and the following disclaimer.

     2. Redistributions in binary form must reproduce the above copyright
        notice, this list of conditions and the following disclaimer in the
        documentation and/or other materials provided with the distribution.

     3. The names of its contributors may not be used to endorse or promote 
        products derived from this software without specific prior written 
        permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
   EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
   PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
   PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
   LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


   Any feedback is very welcome.
   http://www.math.sci.hiroshima-u.ac.jp/~m-mat/MT/emt.html
   email: m-mat @ math.sci.hiroshima-u.ac.jp (remove space)
*/


/* Period parameters */  
#define N 624
#define M 397
#define MATRIX_A 0x9908b0dfUL   /* constant vector a */
#define UPPER_MASK 0x80000000UL /* most significant w-r bits */
#define LOWER_MASK 0x7fffffffUL /* least significant r bits */



CRandom2::CRandom2() {

	m_iaMT.resize(N);
	m_iMTI = N+1;
	m_bGenerate = false;
}



/* initializes mt[N] with a seed */
void CRandom2::init_genrand(unsigned long s)
{
    m_iaMT[0]= s & 0xffffffffUL;
    for (m_iMTI=1; m_iMTI<N; m_iMTI++) {
        m_iaMT[m_iMTI] = 
	    (1812433253UL * (m_iaMT[m_iMTI-1] ^ (m_iaMT[m_iMTI-1] >> 30)) + m_iMTI); 
        /* See Knuth TAOCP Vol2. 3rd Ed. P.106 for multiplier. */
        /* In the previous versions, MSBs of the seed affect   */
        /* only MSBs of the array mt[].                        */
        /* 2002/01/09 modified by Makoto Matsumoto             */
        m_iaMT[m_iMTI] &= 0xffffffffUL;
        /* for >32 bit machines */
    }
}



/* initialize by an array with array-length */
/* init_key is the array for initializing keys */
/* key_length is its length */
/* slight change for C++, 2004/2/26 */
void CRandom2::init_by_array(unsigned long init_key[], int key_length)
{
    int i, j, k;
    init_genrand(19650218UL);
    i=1; j=0;
    k = (N>key_length ? N : key_length);
    for (; k; k--) {
        m_iaMT[i] = (m_iaMT[i] ^ ((m_iaMT[i-1] ^ (m_iaMT[i-1] >> 30)) * 1664525UL))
          + init_key[j] + j; /* non linear */
        m_iaMT[i] &= 0xffffffffUL; /* for WORDSIZE > 32 machines */
        i++; j++;
        if (i>=N) { m_iaMT[0] = m_iaMT[N-1]; i=1; }
        if (j>=key_length) j=0;
    }
    for (k=N-1; k; k--) {
        m_iaMT[i] = (m_iaMT[i] ^ ((m_iaMT[i-1] ^ (m_iaMT[i-1] >> 30)) * 1566083941UL))
          - i; /* non linear */
        m_iaMT[i] &= 0xffffffffUL; /* for WORDSIZE > 32 machines */
        i++;
        if (i>=N) { m_iaMT[0] = m_iaMT[N-1]; i=1; }
    }

    m_iaMT[0] = 0x80000000UL; /* MSB is 1; assuring non-zero initial array */ 
}



/* generates a random number on [0,0xffffffff]-interval */
unsigned long CRandom2::genrand_int32(void)
{
    unsigned long y;
    static unsigned long mag01[2]={0x0UL, MATRIX_A};
    /* mag01[x] = x * MATRIX_A  for x=0,1 */

    if (m_iMTI >= N) { /* generate N words at one time */
        int kk;

        if (m_iMTI == N+1)   /* if init_genrand() has not been called, */
            init_genrand(5489UL); /* a default initial seed is used */

        for (kk=0;kk<N-M;kk++) {
            y = (m_iaMT[kk]&UPPER_MASK)|(m_iaMT[kk+1]&LOWER_MASK);
            m_iaMT[kk] = m_iaMT[kk+M] ^ (y >> 1) ^ mag01[y & 0x1UL];
        }
        for (;kk<N-1;kk++) {
            y = (m_iaMT[kk]&UPPER_MASK)|(m_iaMT[kk+1]&LOWER_MASK);
            m_iaMT[kk] = m_iaMT[kk+(M-N)] ^ (y >> 1) ^ mag01[y & 0x1UL];
        }
        y = (m_iaMT[N-1]&UPPER_MASK)|(m_iaMT[0]&LOWER_MASK);
        m_iaMT[N-1] = m_iaMT[M-1] ^ (y >> 1) ^ mag01[y & 0x1UL];

        m_iMTI = 0;
    }
  
    y = m_iaMT[m_iMTI++];

    /* Tempering */
    y ^= (y >> 11);
    y ^= (y << 7) & 0x9d2c5680UL;
    y ^= (y << 15) & 0xefc60000UL;
    y ^= (y >> 18);

    return y;
}



/* generates a random number on [0,0x7fffffff]-interval */
long CRandom2::genrand_int31(void)
{
    return (long)(genrand_int32()>>1);
}



/* generates a random number on [0,1]-real-interval */
double CRandom2::genrand_real1(void)
{
    return genrand_int32()*(1.0/4294967295.0); 
    /* divided by 2^32-1 */ 
}



/* generates a random number on [0,1)-real-interval */
double CRandom2::genrand_real2(void)
{
    return genrand_int32()*(1.0/4294967296.0); 
    /* divided by 2^32 */
}



/* generates a random number on (0,1)-real-interval */
double CRandom2::genrand_real3(void)
{
    return (((double)genrand_int32()) + 0.5)*(1.0/4294967296.0); 
    /* divided by 2^32 */
}



/* generates a random number on [0,1) with 53-bit resolution*/
double CRandom2::genrand_res53(void) 
{ 
    unsigned long a=genrand_int32()>>5, b=genrand_int32()>>6; 
    return(a*67108864.0+b)*(1.0/9007199254740992.0); 
} 
/* These real versions are due to Isaku Wada, 2002/01/09 added */



